#ifndef __GENERIC
#define __GENERIC

#define TOKENIZE(a,b) a##b
#define TEMPLATE(a,b) TOKENIZE(a,b)
#ifndef type_null
#define type_null TEMPLATE(Type,Null)
#endif

#define ArrayOffsetNormalize(arr,offset) \
  if (offset < 0) offset = ArrayLen0(arr) + offset;	\
  if (offset < 0) offset = 0;\
  if (offset >= ArrayLen0(arr)) offset = ArrayLen0(arr);

#define ArrayLen0(arr) (arr ? ((unsigned *)(arr))[-1] : 0)
#define ArrayLen(arr) (((unsigned *)(arr))[-1])
#define MPtr(arr) (arr ? (((unsigned *)(arr))-1) : 0)
#define APtr(Type,ptr) ((Type *)(((unsigned *)(ptr))+1))

#define NPTR (void *(*)(void *,void *))
#define PPTR (void (*)(void *))
#define CPTR (int (*)(const void *,const void *))

#define New(var,Type,...)  (*(var=(Type *)malloc(sizeof(Type))) =	\
			    (Type){ __VA_ARGS__ }, var)

#define Init(Type,...)  ((Type){ __VA_ARGS__ })

// #define Free(ptr) free(MPtr(ptr))
#endif
/*
  Author: Michael Schmidt (michael@embeddedARM.com)
 */
